<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *  WEB interface for editing study/order data
 *
 *  @param cStudy        Study Instance UID (exclusive with cOrder)
 *  @param cBack         URL to go back after editing  (goes back to Referer if missing)
 *  @param cOrder        Create new order instead of editing existing order/study (exclusive with cStudy)
 *  @param cBreak        The study/order is locked, break the lock
 *  @param cOp           Only accepted value is 'Save' = save changes
 *  @param cMode         Hard or Soft edit (default is soft)
 *
 *   qe_..., qi_..., qo_..., qs_... parameters are auto generated and processed by Types classes
 *   and contains old and new values for study/order attributes.
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="imagemed.dcprocessing.EditStudy"%>
<%@page import="imagemed.exception.IMGeneralException"%>
<%@page import="imagemed.exception.IMException"%>
<%@page import="imagemed.layout.validator.Validator"%>
<%@

	page import="imagemed.layout.datasource.EntryLayoutFactory,
		imagemed.layout.datasource.pointer.FieldPointer,
		imagemed.layout.datasource.pointer.FieldInstancePointer,
		imagemed.layout.datasource.LDSEntry,
		imagemed.layout.datasource.DcmLDSEntry,
		imagemed.dotcom.DotcomConfig,
		imagemed.layout.macro.input.GenericDBInputMacro,
		imagemed.layout.datasource.StudyDataSource,
		imagemed.layout.LayoutRoot,
		imagemed.layout.LayoutPart,
		imagemed.layout.macro.misc.ShredEditMacro,
		imagemed.layout.datasource.SingleStudyDataSource,
		imagemed.types.flag.IMTypeur,
		java.util.*,java.io.*,java.sql.*, imagemed.imsession.*,imagemed.jsputil.*,
		imagemed.util.*,imagemed.types.string.*,imagemed.types.*,
		com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
		imagemed.dicom.*, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!
	static IMTypePN typePN = ( IMTypePN ) IMType.getTypeFor( "PN" );
	static String thisPage = "/cases/edit.jsp";
%><%

	IMSession is = new IMSession( request, response, out );
	String parStudy     = request.getParameter( "cStudy" );
	String parBack      = request.getParameter( "cBack" );
	String parOrder     = request.getParameter( "cOrder" );
	String parBreak     = request.getParameter( "cBreak" );

	String parUser = null;

	String parOp = request.getParameter( "cOp" );
	String entryName = request.getParameter("cEntryName");
	
	boolean isCreateOrder = "true".equals( parOrder );
	boolean isSave  = request.getParameter( "cOp" ) != null &&  request.getParameter( "cOp" ).startsWith( "Save" );
	boolean isSaveUpload = isSave && "SaveAndUpload".equals( request.getParameter( "cOp" ) );
	boolean isSaveScan = isSave && "SaveAndScan".equals( request.getParameter( "cOp" ) );
	boolean isCancel = "Cancel".equals( request.getParameter( "cOp" ) );

	Helper.DEBUG( "parStudy:" + parStudy + " parBack:" + parBack + " parOrder:" +  parOrder + 
	" parBreak:" + parBreak + " parOp:" + parOp + " entryName:" + entryName );
	
	String pna = "";

	String generatedOrderUID = null;
	
	Syslog slog = new Syslog( "edit.jsp", 0 , IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	Connection IMDB = IMEnv.getDB();
	String pageName = "/cases/edit.jsp";

	is.regDest = "/cases/index.jsp";
	is.bRegNotNeeded = isCancel; // Cancel does not require valid session to let the lock released
	if ( !is.regOK() ) {
		return;
	}
	if ( !isCreateOrder ) {
		try {
	if ( !StudyToolbox.isOrder( parStudy ) || DotcomConfig.selfDevice().hasMultipleClusters() ) {
		// getRedirectForStudy() does anything only in a CWL environment on the Worklist server
		// if multiple clusters, it's possible that redirection is needed
		String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
		if ( redirHost != null ) {
	String redirURL = redirHost + "/cases/edit.jsp?" + RedirectToolbox.getRedirectParams( is );
	response.sendRedirect( redirURL );
	return;
		}
	}
		}
		catch (IMException ime) {
	Helper.DEBUG( "cases/edit.jsp", Helper.throwable2String( ime ) );
		}
	}

	Defs casesDefs = new Defs( is, parUser );

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}

	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}

		
	if ( isCancel ) {
		if ( !isCreateOrder ) {
	IMLock.lockStudy( is, parStudy, "Unlock", new Properties() );
		}
		response.sendRedirect( parBack );
		return;
	}
		
	boolean hasSchedulingRight = is.regRights != null && ( -1 != is.regRights.indexOf( 'H' ) );
	boolean hasEditRight = is.regRights != null && ( -1 != is.regRights.indexOf( 'E' ) );
	
	// Check if the user has rights to edit studies and/or creating orders
	if ( ! hasEditRight && ! hasSchedulingRight || ! hasEditRight && ! isCreateOrder ) {
		if ( isCreateOrder ) {
	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "order" );
	logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
	logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no_rights" );
	logEntry.log( "edit.jsp", 0, Syslog.LOG_ERR );

	slog.syslog(Syslog.LOG_ERR, "ERROR STUDY order " + casesDefs.getUser() + " - - - - - - - - - - - no_rights");
	throw new IMGeneralException( is, 
	LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_ACCESS_RIGHT_CREATE_ORDER", new Format[] { null }, new Object[] { is.regID }, true ),
	"cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_ERROR" ), parBack );
		}

		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "edit" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no_rights" );
		logEntry.log( "edit.jsp", 0, Syslog.LOG_ERR );
		
//		slog.syslog(Syslog.LOG_ERR, "ERROR STUDY edit " + casesDefs.getUser() + " - " + parStudy + " - - - - - - - - - - no_rights");
		throw new IMGeneralException( is,
		LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_ACCESS_RIGHT_EDIT_STUDIES", new Format[] { null }, new Object[] { is.regID }, true),
		"cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_ERROR" ), parBack );
	}

	boolean bOrder = isCreateOrder;
	String StudyDir = null;
	if ( !isCreateOrder ) {
		bOrder = StudyToolbox.isOrder( parStudy );
		StudyDir = RepositoryHandler.getLocation( RepositoryHandler.DATA, parStudy );
	}

	// Get Report

	String pbrFileName = null;
	int nWaitTime = 30000; // 30 sec

	try {
		ResultSet rs = IMDB.prepareStatement( "select FNAME from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
		" where STYIUID='" + parStudy + "' AND SOPCLUID='" + IMEnvBase.getEnv( "PBREPORT_SOPCLASS" ) + "'"
		).executeQuery();
		if ( rs.next() )
	pbrFileName = StudyDir + "/" + rs.getString( "FNAME" );
		rs.close();
	}
	catch ( SQLException sqlEx ) {
	}

	TableDescriptorImpl tdesc       = new TableDescriptorImpl();
	WorklistTableParamsImpl tparams = new WorklistTableParamsImpl( is.imRequest, casesDefs.getFilterUser() );
	tparams.setDefaultFields( EditToolbox.allDbColids.toArray( new String[] {} ) );

	if ( parStudy != null ) {
		Properties filters = new Properties();
		filters.setProperty( "SYUI",parStudy );
		tparams.setDefaultFilters( filters );
//		out.println("<!-- default Filters set to SYUI="+parStudy+" in "+tparams+"-->");
	}

	tdesc.setTableParams( tparams );
	tparams.setCalcOnDemand();
//	tdesc.setFieldManager(fm);
	WorklistResultImpl result = new WorklistResultImpl( is, tdesc );
	result.setGlobal( true );
	if ( !isCreateOrder && parStudy != null && !result.next() )
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_ERROR" ), parBack, 4 );

	String logPatient = result.getValue( "PANM", "" );
	String logModality = result.getValue( "MODA", "" );
	String patientName = IMTypePN.displayOrdinaryText( result.getValue( "PANM", "" ) );
	String sourceStudy = result.getValue( "SSUI" );

	//logPatient = Syslog.logValue( logPatient );
	logModality = ( null == logModality || "".equals( logModality ) ) ? "=" : Helper.replace( logModality, " ", "_" );

	Properties logPrp = new Properties();
	logPrp.setProperty( "LOG_PATIENT",  logPatient );
	logPrp.setProperty( "LOG_MODALITY", logModality );

	String lockStudy = parStudy;  // when editing shortcuts, the original study should be locked
	boolean isShortcut = false;   // indicates whether a shortcut is being edited 
	boolean editShortcut = false; // indicates whether edit changes are to be saved for the shortcut or source study
	
	if ( null != sourceStudy && !sourceStudy.equals( parStudy ) ) {
		// editing shortcut
		isShortcut = true;
		lockStudy = sourceStudy;
		editShortcut = "true".equals( IMEnv.getConfigProperty(
		new String[] { StudyDir + "/.info/shortcut.cfg", IMEnvBase.getEnv( "IFACE_VAR" ) + "/edit.cfg" },
		"EditShortcut" ) );
	}
	

	Properties prpLock = new Properties();
	Properties prpLastModified = null;
	String lockID = null;
	boolean bLocked = false;
	boolean bMessageWindow = false;
	String  strMessageType = null;

	if ( !isCreateOrder && !isSave ) {
		if ( parBreak != null ) {
			prpLastModified = Report.getReportModified( is, lockStudy, "Break", prpLock );
		}
		else {
			prpLastModified = Report.getReportModified( is, lockStudy, "Lock", prpLock );
		}

		bLocked = "OK".equals( prpLock.getProperty( "IMLock" ) );
		if ( bLocked) {
			lockID = prpLock.getProperty( "IMLockID" );
			if ( lockID == null ) {
				bLocked = false;
			}
		}

		if ( !bLocked ) {
	bMessageWindow = true;
	strMessageType = "true".equals( prpLock.getProperty( "IM_INTERRUPTED" ) ) ? "Interrupted" : "Break";
	if ( "UNEDITABLE".equals( prpLock.getProperty( "IMLock", "" ) ) )
		strMessageType = "UNEDITABLE";
		}
		else {
	// Check if the report is the recent one
	if ( prpLastModified != null ) {
		int nElapsed = 0;
		while ( ReportToolbox.hasNewerReport( prpLastModified, lockStudy ) && nElapsed < nWaitTime ) {
	Thread.sleep( 50 );
	nElapsed += 50;
		}

		if ( ReportToolbox.hasNewerReport( prpLastModified, lockStudy ) ) {
	IMLock.lockStudy( is, lockStudy, "Unlock", new Properties() );
	bMessageWindow = true;
	strMessageType = "Modified";
		}
	} // prpLastModified != null
		} // bLocked
	} // !isCreateOrder && !isSave

%><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "termSTUDY", true) %></title>
<SCRIPT language="JavaScript">
	var ua = navigator.userAgent.toLowerCase();
	var isIE = ( ( ua.indexOf( "msie" ) != -1 ) && ( ua.indexOf( "opera" ) == -1 ) && ( ua.indexOf( "webtv" ) == -1 ) ) ? true : false;
</SCRIPT>
<%
	JSHelper.printJsInclude( is.out, JSHelper.LAYOUTSCRIPTS_JS );
	JSHelper.printJsInclude( is.out, JSHelper.JQUERY_JS );
	if ( lockID == null ) {
		lockID = IMLock.getLockIDFromIS( is );
	}
	
	TabToolbox.writeIMpopup( is.out );
%>
<SCRIPT language="JavaScript">
	
	var needUnlock = true; // in default unlock study when leaving page

	var chShredChecked = false; // Was the Shred checkbox checked or not
	
	var popupRef = null;
	
	var needClosePopup = false; // by default do NOT close popup upload window when leaving page
	
	function unlockStudy() { //also close poup window if needed
		if( needClosePopup ) {
			if( popupRef == null ) {
				popupRef = window.open( '', 'Upload' );
			}
	
			if( popupRef != null ) {
				popupRef.window.close();
			}
		}
		
		if (needUnlock) {
			try {
				console.log( "unlocking started" );
			}
			catch (e){}
			$.ajax({
  			type: 'POST',
  			url: '/cases/unlockwindow.jsp',
  			data: 'study=<%=lockStudy%>&cIMLockID=<%=lockID%>',
				async: false,
				success: function() {
					needUnlock = false;
					try {
						console.log( "unlocking succeeded" );
					}
					catch (e){}
			    },
				error: function (xhr, ajaxOptions, thrownError) {
					try {
						console.log( "unlocking failed:" );
				    	console.log(xhr.status);
				    	console.log(thrownError);
					}
					catch (e){}
				}
			});
		}
	}

	$(document).ready(function(){
		window.onbeforeunload = function(){
			unlockStudy();
		}
	});

	// used to submit edit form
	function submitEdit(frm, oper) {
		needUnlock = false;  // in case of save study should not be unlocked
		
		//ez a magia azert van, mert csak gombnyomaskor tudunk popup ablakot nyitni, egyebkent blokkolodhat
		//ezert itt megnyitjuk, de ugye itt meg nincs save-elve a study, szoval csak kesobb lesz ertelmes az ablak
		//addig csak dummy
		
		if( oper == 'SaveAndUpload' || oper == 'SaveAndScan' ) {
		  if( isIE ) {
		  	if( oper == 'SaveAndUpload' ) {
		  		var left = ( screen.width / 2 ) - ( <%=AttachmentManager.UPLOADWINDOW_WIDTH%> / 2 );
		  		var top = ( screen.height / 2 ) - ( <%=AttachmentManager.UPLOADWINDOW_HEIGHT%> / 2 );
					popupRef = window.open( '/cases/hiddenPopup.html', 'Upload', 'left=' + left + ', top=' + top + ', width=<%=AttachmentManager.UPLOADWINDOW_WIDTH%>, height=<%=AttachmentManager.UPLOADWINDOW_HEIGHT%>, scrollbars=auto, resizable=yes' );
				}
				else {
					popupRef = window.open( '/cases/hiddenPopup.html', 'Upload', 'fullscreen=yes, scrollbars=auto, resizable=yes' );
				}				
		  }
		  else {
				popupRef = window.open( '/cases/hiddenPopup.html', 'Upload', 'left=1, top=1, width=1, height=1, scrollbars=auto, resizable=yes' );
			}
			popupRef.blur();
		}
		frm.cOp.value = oper;
		frm.submit();
	}

	// used to submit break lock form
	function doSubmit(frm) {
		needUnlock = false;  // in case of save study should not be unlocked
		frm.submit();
	}

	function openSelect(lnk, wid) {
		newWin = window.open(lnk, 'selectW_', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width='+wid+',height=360');
		newWin.focus();
	}

	function changeEditShortcut() {
		var spanShred = document.getElementById("shred");

		var chShortcut = self.document.editForm.cEditShortcut;
		var chShred = self.document.editForm.cMode;

		if ( spanShred ) {
			if ( chShortcut.checked ) {
				<%= is.isMSIE() ? "spanShred.style.display = \"none\"" : "spanShred.style.visibility = \"hidden\"" %>;
				chShredChecked = chShred.checked;
				chShred.checked = false;
			}
			else {
				<%= is.isMSIE() ? "spanShred.style.display = \"inline\"" : "spanShred.style.visibility = \"visible\"" %>;
				chShred.checked = chShredChecked;
			}
		}
	}
	
</SCRIPT>
<%TableImpl.printCommonScript(is);%>
</head>

<BODY onUnload='unlockStudy()'>
<CENTER>
<%

	// Check if all of the objects in the study can be edited (storelevel is not 'Staged')
	if ( !isCreateOrder ) {
		EditToolbox.isStudyEditable( is, parStudy, patientName, parBack ); // Will throw an exception if study is uneditable
	}


	String tab = "cases/index.jsp";

	if ( isCreateOrder ) {
		tab = "cases/edit.jsp?cOrder=true";
	}

	TabToolbox.makeTabs( is, is.tabbean, tab, "White" );

	/********************
	 *   Save changes   *
	 ********************/
	String saveHtml = null;
	MessageBox saveMessageBox = null;
	if ( isSave ) {
		
		SingleStudyDataSource dataSource = new SingleStudyDataSource( is, bOrder?LayoutPart.ORDERLAYOUT:LayoutPart.STUDYEDITLAYOUT );
		
  	LDSEntry entry = null;
  	if (entryName != null) {
  		entry = LDSEntry.readFile(is, entryName, dataSource);
  		dataSource.setEntry(entry);
  		entry.initFromRequest(is.imRequest);
  		
  		pna = entry.getRootRecord().getCurrentValue( "PANM", "" );
  		Helper.DEBUG( "patient from entry:" + pna );
  	}
  	else {
  		throw new RuntimeException("saving a study/order edit/create form, but cEntryName is missing...");
  	}
  	dataSource.setRepeatPointer(dataSource.getTable(), 0);

		String editURL = thisPage + "?cOp="; //empty means edit
		String saveURL = thisPage + "?cOp=" + parOp;
		if( isCreateOrder ) {
			saveURL += "&cOrder=true";
			editURL += "&cOrder=true";
		}
		else {
			saveURL += "&cStudy=" + parStudy;
			editURL += "&cStudy=" + parStudy;
		}
		String otherPar = "&cBreak=" + parBreak;
		saveURL += otherPar;
		editURL += otherPar;
		if (!Validator.doValidation(is, bOrder ? LayoutPart.ORDERLAYOUT : LayoutPart.STUDYEDITLAYOUT, dataSource, editURL, saveURL )) {
			// form with errors or warnings displayed...
			return;
		}


		
// check illegal '^' characters in parts of names
// 			String[] nameFields = { "PANM", "PHRF", "PHRR", "PHRD", "PHPR", "RQPH" };
// 			String[] nameParts  = { "last", "first", "pref", "mi", "postf" };
// 			for ( int i = 0; i < nameFields.length; i++ ) {
// 				String fid = nameFields[ i ];
// 				for ( int j = 0; j < nameParts.length; j++ ) {
// 					String part = is.request.getParameter( "qi_" + fid + "_" + nameParts[ j ] );
// 					if ( part != null && part.indexOf( '^' ) != -1 )
// 						throw new IMException( LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_INVALID_CHARACTERS", new Format[] { null }, new Object[] { IMBaseFieldManager.staticGetUiName( fid ) }, true) );
// 				}
// 			}

	  	
		// check empty fields, status backwards and check duplicate is in the (pre-)validator

		// generate Order ID (STYIUID)
		try {
			Set<FieldInstancePointer> changedFields = entry.commit();
			// save succeeded
			StringBuilder disp = new StringBuilder();
			for (FieldInstancePointer fip : changedFields) {
				String field = fip.m_sfieldID;
				String value = dataSource.getValue( fip );
				disp.append(IMBaseFieldManager.staticGetUiName( field ) + " := " + IMBaseFieldManager.DEFAULTFIELDMANAGER.display( value, field, null, EditStudy.DISPLAY_PROPERTIES, is ) + "<BR>");
			}
			if (isCreateOrder) {
				saveHtml = "<H2><P>&nbsp;<P>" + LocalizedMessage.getSimpleMessage( "CASES_EDIT_CREATED_NEW_ORDER" ) + ":</h2><H3>" + disp + "</h3>";
				generatedOrderUID = dataSource.getValue( "SYUI" );
			}
			else {
				saveHtml = "<H2><P>&nbsp;<P>" + LocalizedMessage.getSimpleMessage( "CASES_EDIT_MODIFIED_STUDY" ) + ":<P>" + patientName + "</h2><H3>" + disp +"</h3>";
				saveHtml = saveHtml + "\n<Script language=\"JavaScript\">";
				saveHtml = saveHtml + "\n  needUnlock = false;";
				saveHtml = saveHtml + "\n</Script>\n";
			}
		}
		catch (IMException ime) {
			// saving failed
			saveHtml = ime.getMessage();
		}
			// order log entry is created by processorder
			
			
		if( isSaveUpload || isSaveScan) {
			String wh = "";
			String doctypeDefault;
			if( isSaveUpload ) {
				doctypeDefault = AttachmentManager.getDefaultDoctypeName( "DTQU" );
			}
			else {
				doctypeDefault = AttachmentManager.getDefaultDoctypeName( "DTQD" );
			}
			//we use the same default as on QV page
//					String scanURL = "/cases/prePACSOrderScan.jsp?id=" + Helper.URLEncodeUTF8( generatedOrderUID ) + "&cStudyIUID=" + Helper.URLEncodeUTF8( generatedOrderUID ) + "&isUID=true&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) + "&cUploadOnly=true";
			String scanURL = null;
			if( isCreateOrder ) { //newly created order
				if( generatedOrderUID == null ) {
					Helper.ERRORLOG( "generatedOrderUID is null!" );
				}
				else {
					scanURL = "/cases/prePACSOrderScan.jsp?id=" + Helper.URLEncodeUTF8( generatedOrderUID ) + "&cStudyIUID=" + Helper.URLEncodeUTF8( generatedOrderUID ) + "&isUID=true";
				}
			}
			else {
				if( StudyToolbox.isOrder( parStudy ) ) {
					//existing order
					scanURL = "/cases/prePACSOrderScan.jsp?id=" + Helper.URLEncodeUTF8( parStudy ) + "&cStudyIUID=" + Helper.URLEncodeUTF8( parStudy ) + "&isUID=true";
				}
				else {
					//study
					scanURL = "/cases/preDicomScan.jsp?cStudyIUID=" + Helper.URLEncodeUTF8( parStudy );
				}
			}
			
			if( scanURL != null ) {
				scanURL += "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault );
				if( isSaveUpload ) {
					scanURL += "&cUploadOnly=true";
					wh = "width=" + AttachmentManager.UPLOADWINDOW_WIDTH + ", height=" + AttachmentManager.UPLOADWINDOW_HEIGHT + ", ";
				}
				Helper.DEBUG( "SCANURL:" + scanURL );
%>
				<SCRIPT language="JavaScript">
					popupRef = window.open( '', 'Upload', '<%=wh%> scrollbars=auto, resizable=yes' );
					if( popupRef != null ) {
						if( !isIE ) {
<%
							if( isSaveUpload ) {
%>					
								popupRef.window.resizeTo( <%=AttachmentManager.UPLOADWINDOW_WIDTH%>, <%=AttachmentManager.UPLOADWINDOW_HEIGHT%> );
								popupRef.window.moveTo( ( screen.width / 2 ) - ( <%=AttachmentManager.UPLOADWINDOW_WIDTH%> / 2 ), screen.height / 2 - <%=AttachmentManager.UPLOADWINDOW_HEIGHT%> / 2 );
<%		
							}
							else {
%>						
								popupRef.window.moveTo( 0, 0 );
								popupRef.window.resizeTo( screen.availWidth,screen.availHeight );
<%								
							}
%>
						}
						popupRef.window.location = '<%=scanURL%>';
						popupRef.window.focus();
					}
				</SCRIPT>
<%
	}
		} // upload/scan

		
// check illegal '^' characters in parts of names
// 			String[] nameFields = { "PANM", "PHRF", "PHRR", "PHRD", "PHPR", "RQPH" };
// 			String[] nameParts  = { "last", "first", "pref", "mi", "postf" };
// 			for ( int i = 0; i < nameFields.length; i++ ) {
// 				String fid = nameFields[ i ];
// 				for ( int j = 0; j < nameParts.length; j++ ) {
// 					String part = is.request.getParameter( "qi_" + fid + "_" + nameParts[ j ] );
// 					if ( part != null && part.indexOf( '^' ) != -1 )
// 						throw new IMException( LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_INVALID_CHARACTERS", new Format[] { null }, new Object[] { IMBaseFieldManager.staticGetUiName( fid ) }, true) );
// 				}
// 			}

	  	
		// check empty fields, status backwards and check duplicate is in the (pre-)validator

		// generate Order ID (STYIUID)
		try {
	Set<FieldInstancePointer> changedFields = entry.commit();
	// save succeeded
	StringBuilder disp = new StringBuilder();
	for (FieldInstancePointer fip : changedFields) {
		String field = fip.m_sfieldID;
		String value = dataSource.getValue( fip );
		disp.append(IMBaseFieldManagerImpl.staticGetUiName( field ) + " := " + IMBaseFieldManagerImpl.DEFAULTFIELDMANAGER.display( value, field, null, EditStudy.DISPLAY_PROPERTIES, is ) + "<BR>");
	}
	if (isCreateOrder) {
		saveHtml = "<H2><P>&nbsp;<P>" + LocalizedMessage.getSimpleMessage( "CASES_EDIT_CREATED_NEW_ORDER" ) + ":</h2><H3>" + disp + "</h3>";
		generatedOrderUID = dataSource.getValue( "SYUI" );
	}
	else {
		saveHtml = "<H2><P>&nbsp;<P>" + LocalizedMessage.getSimpleMessage( "CASES_EDIT_MODIFIED_STUDY" ) + ":<P>" + patientName + "</h2><H3>" + disp +"</h3>";
		saveHtml = saveHtml + "\n<Script language=\"JavaScript\">";
		saveHtml = saveHtml + "\n  needUnlock = 0;";
		saveHtml = saveHtml + "\n</Script>\n";
	}
		}
		catch (IMException ime) {
	// saving failed
	saveHtml = ime.getMessage();
		}
	// order log entry is created by processorder
	} // Save

	
	if ( isSave ||
	( parStudy == null && ! isCreateOrder ) ) {
%><script language="JavaScript">
		setTimeout( "document.location='<%=parBack%>';", 3000 );
	</script><%

	}
	
	if ( isSave ) {
		if ( saveMessageBox != null ) {
			out.println( "<BR>" );
			saveMessageBox.print( is.out );
			out.println( "</center></body></html>" );
			return;
		}

		if ( saveHtml != null ) {
			out.println( saveHtml );
			out.println( "</center></body></html>" );
			return;
		}
	}


	if ( bMessageWindow ) {
		if ( "Modified".equals( strMessageType ) ) {
			throw new IMGeneralException( is,
					LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_STUDY_MODIFIED_HASNT_ARRIVED" ),
					tab, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_ERROR" ), parBack );
		}
		else if( "Interrupted".equals( strMessageType ) ) {
			throw new IMGeneralException( is,
					LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_CANT_LOCK_STUDY" ),
					tab, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_LOCK_UNAVAILABLE" ), parBack );
		}
		else if ( "UNEDITABLE".equals(strMessageType ) ) {
			// We should never get here, isStudyEditable will catch it before.
			// But for safe ...
			MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_UNEDITABLE" ),"60%" );

			box.setMessage( "<center><H2><BR>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_EDIT_CANT_EDIT_STUDY_DISABLED", new Format[] { null, null }, new Object[] { patientName, parStudy }, true) + "</BR></BR></H2></center>" );
			box.addButton( new Button( parBack, "BUTTON_CANCEL","BUTTON_CANCEL" ) );
%>
<BR><%
	box.print( is.out );
		}
		else { // Break
	String lockerName = prpLock.getProperty( "IMLockOwner" );
	String lockAge = prpLock.getProperty( "IMLockAge" );
	lockerName = ( null == lockerName ) ? LocalizedMessage.getSimpleMessage( "GENERIC_ANOTHER_USER" ) : IMTypePN.displayOrdinaryText( lockerName );

	MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_LOCKED" ),"60%" );
	box.setMessage( "<H2><BR>" + LocalizedMessage.getCompoundMessage( "STUDY_LOCK_LOCKED_BY", new Format[] { null, null }, new Object[] { lockerName, ReportToolbox.getLockAgeMessage( lockAge ) }, true) + "<BR><BR></H2>" );

	String lockMessage;
	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		lockMessage = "STUDY_LOCK_LOCKED_BY";
	}
	else {
		lockMessage = "STUDY_LOCK_LOCKED_BY_NO_BREAK";
	}
		
	box.setMessage( "<H2><BR>" + LocalizedMessage.getCompoundMessage( lockMessage, new Format[] { null, null }, new Object[] { lockerName, ReportToolbox.getLockAgeMessage( lockAge ) }, true) + "<BR><BR></H2>" );

	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		box.addButton( new Button( "javascript:doSubmit(self.document.breakForm);", "BUTTON_BREAK", "BUTTON_BREAK_TITLE" ) );
	}
	
	box.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_CANCEL" ) );

%>
    <FORM action="<%= pageName %>" method=get name="breakForm">
<%
			box.print( is.out );

			if ( lockID != null ) {
%>
    <INPUT type="hidden" name="cIMLockID" value="<%=lockID%>">
<%
			}
			String referringHost = RedirectToolbox.getReferringHost( is );
			if ( referringHost != null && referringHost.length() > 0 ) {
%>
    <INPUT type="hidden" name="RefererHost" value="<%=referringHost%>">
<%
			}
			if ( is.isParentSession ) {
%>
    <INPUT type="hidden" name="ParentSession" value="<%=is._sid.substring( 1 )%>">
<%
			}
			
%>
    <INPUT type="hidden" name="cStudy" value="<%=parStudy%>">
    <INPUT type="hidden" name="cBack" value="<%=Helper.htmlEncode( parBack )%>">
    <INPUT type="hidden" name="cBreak" value="true">
    </FORM>
<%
		} // Break lock window
%>
    <script language="JavaScript">
      needUnlock = false;  // study was not locked
    </script>
    </center></body></html>
<%
		return;
	} // Message Window


	// Read Report file for fields not stored in database

	String hasReport = "false";

	DicomItem dItem = null;
	
	if ( pbrFileName != null ) {
		DicomParser dParser = new DicomParser( pbrFileName );
		try {
			dParser.parse();
		}
		catch( Exception e ) {
			is.out.println( Helper.throwable2String( e ) );
			return;
		}
		DicomFile dicomFile = DicomFile.createDicomFile( dParser );
		DicomParser parser = dicomFile.getDicomParser();
		dItem = parser.getDataset();
	}

	try {
		// Only for backward compatibility
		hasReport = ( EditToolbox.hasReport( pbrFileName ) ) ? "true" : "false";
		if ( !"true".equals( hasReport ) ) {
			ResultSet rs = IMDB.prepareStatement( "select INTSOPIUID from " + IMEnvBase.getEnv( "REPORTTBL" ) +
					" where SRCSTUDY='" + parStudy + "'" ).executeQuery();
			hasReport = "" + rs.next();
			rs.close();
		}
	}
	catch ( Throwable th ) {
		th.printStackTrace( is.out );
	}

  // --- Prepare editing ---
//<FONT face="Arial,Helvetica,Universe">
	Properties extraPar = new Properties();
		
	// Enable setting status to any state if there is no report
	extraPar.setProperty( "HasReport", hasReport );
	if ( parStudy != null ) {
		// Pass study UID for editing comments (long values)
		extraPar.setProperty( "StudyInstanceUID", parStudy );
	}
	if ( isCreateOrder ) {
		// Order => all fields sould be saved.
		extraPar.setProperty( "EmptyInit", "" );
	}
	if ( sourceStudy != null && !sourceStudy.equals( parStudy ) ) {
		// Disable status editing for shortcuts
		// TODO: may depend on shortcut properties
		extraPar.setProperty( "IsShortcut", "true" );
	}

	// Max length of input fields
	extraPar.setProperty( IMType.MAXINPUTLENGTH, "60" );
	SingleStudyDataSource dataSource = new SingleStudyDataSource( is, bOrder?LayoutPart.ORDERLAYOUT:LayoutPart.STUDYEDITLAYOUT );
	
	dataSource.addExtraPars( extraPar );

	DcmLDSEntry entry;
	if (entryName != null) {
		entry = (DcmLDSEntry)LDSEntry.readFile(is, entryName, dataSource);
		dataSource.setEntry(entry);
		entry.initFromRequest(is.imRequest);
	}
	else {
		entry = new DcmLDSEntry(dataSource);
 		if ( !isCreateOrder ) {
   		dataSource.setEntry(entry);
 			entry.initFromExisting( parStudy );
 		}
 		else {
			entry.addRecord(dataSource.getTable(), null); // root record
  		dataSource.setEntry(entry);
			// scheduled date is in the prevalidator - Order only and if not set
 		}
	}
	
	LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout( is, bOrder ? LayoutPart.ORDERLAYOUT : LayoutPart.STUDYEDITLAYOUT );

%>
  <FORM method="post" name="editForm" action="edit.jsp">
		<%=root.getHtml( "", LayoutPart.EDITING, dataSource )%>
<%
	if ( isCreateOrder ) {
		out.println( "  <INPUT type=\"hidden\" name=\"cOrder\" value=\"true\"> ");
	}
  String savedName = LDSEntry.writeFile(is, entry);
%>
<input type=hidden name=cEntryName id=cEntryName value="<%=savedName%>">
<%-- <pre><%= result.getDebug() %></pre> -- %>
<input type=hidden name="cOp" value="">
<input type=hidden name=cIMLockID value="<%= Helper.htmlEncode(lockID) %>">
<input type=hidden name=cStudy value="<%= Helper.htmlEncode(parStudy) %>">
<input type=hidden name=cBack value="<%= Helper.htmlEncode(parBack) %>">
<%
	String referringHost = RedirectToolbox.getReferringHost( is );
	if ( referringHost != null && referringHost.length() > 0 ) {
%>
    <INPUT type="hidden" name="RefererHost" value="<%=referringHost%>">
<%
	}%>
</form>
<%
	if ( isCreateOrder ) {
%>
<script language="JavaScript">
<%
		Enumeration<?> enum0 = request.getParameterNames();
		while( enum0.hasMoreElements() ) {
			String name = (String) enum0.nextElement();
			if ( name.startsWith( "q" ) ) {
				String value = request.getParameter( name );
				if ( value != null && !value.equals( "" ) ) {
					value = Helper.protect( value );
					out.println( "self.document.editForm." + name + ".value = '" + value + "';" );
				}
			}
		}
%>
</script>
<%
	}
%>
</body>
</html>
--%>