<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Gets study information and returning for an AJAX request
 *
 *  @param cStudy     Study Instance UID of the study
 *  @param cOp        Info type to be collected
 *  @param cMode      Identifies resource within info type
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@
	page import="java.io.*, java.util.*, java.sql.*, imagemed.imsession.*, imagemed.util.*"

%><%IMSession is = new IMSession(request, response, out);

	is.bRegNotNeeded = true;
	try {
		is.regOK();
	}
	catch (Throwable th) {
	}

	boolean hasSupportRight = is.hasRight( imagemed.types.flag.PacsRight.Support.letterString() );

	if ( !hasSupportRight ) {
		is.out.print( "Has no right to perform this operation" );
		return;
	}

	String study = request.getParameter( "cStudy" );
	String op = request.getParameter( "cOp" );
	String mode = request.getParameter( "cMode" );
	
	try {
		if ( "ls".equals( op ) ) {
			Vector<String> cmd = new Vector<String>();
			cmd.add( "ls" );
			cmd.add( "-l" );
			if ( "studydata".equals( mode ) ) {
				cmd.add( RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DICOM_DATA" ), study ) );
			}
			else if ( "studyinfo".equals( mode ) ) {
				cmd.add( RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DICOM_DATA" ), study ) + "/.info" );
			}
			else if ( "processed".equals( mode ) ) {
				cmd.add( RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_PROCESSED" ), study ) );
			}
			else if ( "cache".equals( mode ) ) {
				cmd.add( RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_CACHE" ), study ) );
			}
			else if ( "archive".equals( mode ) ) {
				String archiveConf = IMEnv.getConfigProperty( IMEnvBase.getEnv( "ARCHIVE_VAR" ) + "/archive.cfg", "Archive" );
				boolean hasArchive = "yes".equals( archiveConf ) || "readonly".equals( archiveConf );
				String archiveDir = null;
				if ( ! hasArchive ) {
					is.out.println( "No archive configure" );
					return;
				}
				
				ResultSet rs = IMEnv.getDB().prepareStatement( "select ARCHDIR from Archive where STYIUID='" + study + "'" ).executeQuery();
				if ( ! rs.next() ) {
					rs.close();
					is.out.println( "Study was not found in the archive" );
					return;
				}
				cmd.add( IMEnvBase.getEnv( "ARCHIVE_DIR" ) + "/" + rs.getString( "ARCHDIR" ) + "/" + study );
				rs.close();
			}
			else {
				is.out.println( "Unrecognized mode: " + mode );
				return;
			}
			
			RunCommandResult res = Helper.runCommandEx( cmd.toArray( new String[0] ), null );
			if ( res.getExitCode() == 0 ) {
				is.out.println( "OK: " + "<pre>" + Helper.htmlEncode( res.getOutput() ) + "</pre>" );
				return;
			}
			
			is.out.println( "ls returned error: " + Helper.htmlEncode( res.getError() ) );
		}
		else {
			is.out.println( "Unrecognized operation: " + op );
		}
	}
	catch ( Throwable th ) {
		is.out.println( "Exception cought: " + Helper.throwable2String( th ) );
		return;
	}

	if ( true ) {
		return;
	}%>
--%>