<%@page import="com.erad.pacs.connector.Connector"%><%@page import="com.erad.pacs.services.usermanager.client.Session"%><%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%><%@page import="java.nio.charset.Charset"%><%@page import="imagemed.http.Range"%><%--
 ** Component: cases
 **
 ** Description:
 **   this jsp page is intended to be used in popup windows to show an attachment image
 **   
 **
 ** Parameters: 
 **
 **  @param type             the type of the attachment (directory level 1)
 **  @param id               the id of the attachment (directory level 2)
 **  @param name             the name of the attachment file
 **  @param cFileName        relative path to the attachment file (to atachment root directory) 
 **  @param cContentType     the content type to be set
 **  @param cExport          true indicates to write the file content to output instead of redirecting
 **  @param cEmbed           true indicates the content will be embedded to an HTML page
 **                          (don't set content-disposition)
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
 
 !!!! DO NOT WRITE INTO THE HTML! NOT EVEN NEWLINE!
--%><%@
	page import="imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.util.Helper"
	
%><%!
	static final int SIZE = 20480;

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	// is.setNonCacheable() does not work on IE over HTTPS
	response.setHeader( "Cache-control", "must-revalidate" );

	String type = request.getParameter( "type" );
	String id = request.getParameter( "id" );
	String name = request.getParameter( "name" );
	String parFileName = request.getParameter( "cFileName" );
	boolean isExport = "true".equals( request.getParameter( "cExport" ) );
	boolean isEmbed = "true".equals( request.getParameter( "cEmbed" ) );
	boolean isImage = AttachmentManager.isImage( parFileName ) || AttachmentManager.isImage( name );

	String fname = "";

	Helper.DEBUG( "showattachment.jsp runs BUU" );
	
	if ( isExport || isImage ) {
		if( Helper.checkFileName( parFileName ) ) {
			fname = AttachmentManager.getDirRoot() + "/" + parFileName;
		}
		else if ( (type != null && type.length() > 0 ) &&
				( id != null && id.length() > 0 ) &&
				Helper.checkFileName( name ) ) {
			fname = AttachmentManager.getFile( type, id, name );
		}
		else {
			Helper.ERRORLOG( "INVALID FILENAME (0):" + parFileName  + " name:" + name );
			throw new RuntimeException( "Invalid showattachment.jsp call, type=" + type + "id=" + id + "name=" + name );
		}

		if ( isExport ) {
			String downloadName;
			if ( parFileName != null && !"".equals( parFileName ) ) {
				downloadName = parFileName;
			}
			else {
				downloadName = name;
			}
			if ( !isEmbed ) {
				response.addHeader( "Content-Disposition", "attachment; filename=\"" + downloadName + "\"" );
			}
			String contentType = request.getParameter( "cContentType" );
			if ( contentType != null && contentType.length() > 0 ) {
				response.setContentType( contentType );
			}
		}
		else {
			response.setContentType( "image/jpeg" );
		}
		
		Helper.DEBUG( "SHOWATTACHMENT filename:" + fname );
		
		Range range = new Range( request, response );

		try {
			range.sendRequestedRange( fname );
			return;
		}
		catch( Throwable t1 ) {
			// not found or other I/O error

			Helper.ERRORLOG( "SEND RANGE PROBLEM:" + Helper.throwable2String( t1 ) );
			
			//response.setStatus(404);
			response.setHeader( "Content-type", "text/html" );
			String msg = "<HTML>\n" + 
					"<HEAD><TITLE>Not Found</TITLE></HEAD>\n" +
					"<BODY><H2>File " + fname + " not found...</H2></BODY>\n" +
					"</HTML>\n";
			response.setHeader( "Content-length", Integer.toString( msg.length() ) );
			out.print( msg );
		}
	}
	else {	
		//direct link
		
		
		if( Helper.checkFileName( parFileName ) ) {
			fname = "/attachment/" + parFileName;
		}
		else if ( ( type != null && type.length() > 0 ) &&
				( id != null && id.length() > 0 ) &&
				Helper.checkFileName( name ) ) {
			fname = AttachmentManager.getFileLink( type, id, name );
		}
		else {
			Helper.ERRORLOG( "INVALID FILENAME:" + parFileName  + " name:" + name );
			throw new RuntimeException( "Invalid showattachment.jsp call, type=" + type + "id=" + id + "name=" + name );
		}

		int lastper = fname.lastIndexOf( "/" );
		String realName = fname.substring( lastper + 1 );
		String path = fname.substring( 0, lastper + 1 );
		
		Helper.DEBUG( "realname:" + realName + " path:" + path );
		
		// sendredirect will put a location='whatever' into the header
		// the header's encoding is known by the browser, urlencode will ensure it's correct
		realName = Helper.URLEncode( realName, "" + Charset.defaultCharset(  ) );
		fname = path + realName;
		
		/*
		byte[] b = fname.getBytes(); //ahogy a file-nev ki van irva
		//mert a buta browser igy erti!?
		fname = new String( b, "ISO-8859-1" );
		
		//ez onmagaban nem jo, de elvileg kell
		// The implementation of this method includes the logic to determine whether the session ID needs to be encoded in the URL
		// All URLs sent to the HttpServletResponse.sendRedirect method should be run through this method. Otherwise, URL rewriting cannot be used with browsers which do not support cookies. 
		fname = response.encodeRedirectURL( fname );
		*/
		
		Helper.DEBUG( "SHOWNAME:" + Helper.debugHex( fname ) );
		
		response.sendRedirect( fname );
		return;
	}	

%>
