<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Displays a patientfolder-style timeline to show availability of studies identified by Study Instance UIDs and/or Accession Numbers
 * 
 *
 * @params:
 *
 *   ACCN   accession number of studies to query
 *          More than one accession number can be specified separated by semicolon (;)
 *   SYUI   study instance UID of studies to query
 *          More than one study can be specified separated by semicolon (;)
 *  [PAID]  patient ID, if provided all studies should belonged to this patient
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="java.util.HashSet"%>
<%@page import="java.util.Set"%>
<%@page import="com.erad.pacs.common.types.ResultCollectorThread"%>
<%@page import="java.util.Vector"%>
<%@page import="java.util.List"%>
<%@page import="com.erad.pacs.common.interfaces.result.Result"%>
<%@page import="imagemed.imsession.IMSession"%>
<%@page import="imagemed.util.*,imagemed.jsputil.*,imagemed.http.tabs.TabBean,imagemed.layout.TimeLine,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.exception.IMException"
%><%IMSession is = new IMSession( request, response, out );
	is.setNonCacheable();
	if ( !is.regOK() ) {
		return;
	}

	if ( "true".equals( is.imRequest.getVal( "cRefresh" ) ) ) {
		try {
			Result wlr = StudyFinder.getWorklistResultSYUI( is.imRequest.getVal( "cGr" ) );
			List<String> res = new Vector<String>();
			while ( wlr.next() ) {
				res.add( wlr.getValue( "SYUI" ) );
			}
			wlr.close();
			out.print( JSHelper.toJSON( res ) );
			//out.print(JSHelper.toJSON( new String[]{is.imRequest.getVal( "cGr" ) })); // test
		}
		catch ( Throwable th ) {
			out.print( JSHelper.toJSON( Helper.toString( th ) ) );
		}
		return;
	}%>
<html>
<head>
<%
	TabBean.writeStyleOnly( is );
	out.println( StyleToolbox.getStylePart( is, "IMTimeLine" ) );
	out.println( StyleToolbox.getStylePart( is, "PatientFolder" ) );
	JSHelper.printJsInclude( out, JSHelper.PATIENTFOLDERSCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
	JSHelper.printJsInclude( out, JSHelper.TABLESCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.TIMELINESCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.IMTIMELINESCRIPTS_JS ); 
	JSHelper.printJsInclude( out, JSHelper.IMIFRAME_JS );
	JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
%>
<style>
			BODY {
				padding: 0px;
				margin: 0px;
			}
</style>
<script language=javascript>
	ButtonTitles[ "ViewerOpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_ADD_STUDY" )%>";
	ButtonTitles[ "OpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" )%>";
	ButtonTitles[ "RetrieveButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_RETRIEVE_STUDY" )%>";
	ButtonTitles[ "QVButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_QV_STUDY" )%>";
	ButtonTitles[ "BackButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_BACK" )%>";
<%String vsId = request.getParameter( "ViewSessionID" );
	if ( vsId != null && vsId.length( ) > 0 ) {
		Cookie coo = new Cookie( "ViewSessionID", vsId );
		coo.setPath( "/" );
		response.addCookie( coo );%>
var ViewSessionID = "<%=vsId%>";
<%}%>
</script>
</head>
<body>
<%
	String parAccno = request.getParameter( "ACCN" );
	String parStudies = request.getParameter( "SYUI" );
	String parPatient = request.getParameter( "PAID" );
	
	if ( parAccno == null && parStudies == null ) {
		IfaceToolbox.printXMLError( is, "Missing Parameter.", true );
		return;
	}
	
	boolean hasArchive = imagemed.http.tabs.TabBean.hasArchive();
	
	Vector<ResultCollectorThread> results = new Vector<ResultCollectorThread>( 4 );

	if ( parStudies != null ) {
		Result wlRes = StudyFinder.getWorklistResultSYUI( parStudies );
		if ( wlRes != null ) {
	results.add( new ResultCollectorThread( wlRes ) );
		}
	}	
	if ( parAccno != null ) {
		Result wlRes = StudyFinder.getWorklistResultACCN( parAccno, parPatient );
		if ( wlRes != null ) {
	results.add( new ResultCollectorThread( wlRes ) );
		}
	}
	if (hasArchive) {
		if ( parStudies != null ) {
	Result aRes = StudyFinder.getArchiveResultSYUI( parStudies );
	if ( aRes != null ) {
		results.add( new ResultCollectorThread( aRes ) );
	}
		}
		if ( parAccno != null ) {
	Result aRes = StudyFinder.getArchiveResultACCN( parAccno, parPatient );
	if ( aRes != null ) {
		results.add( new ResultCollectorThread( aRes ) );
	}
		}
	}

	for ( ResultCollectorThread thread : results ) {
		thread.start();
	}
%>
	<table cellspacing=0 cellpadding=0 height=100%>
	<tr><td>
	<div class='TlButtonsContainer' id='tlbc'></div>
	</td></tr><tr height=100%><td>
	<div id="tlBox" class="tlBox"></div>
	</td></tr>
	</table>
	<Script>
	var sid='<%=is._sid%>';
	var timeLine= new Timeline('tlBox');
	var tc;
	<%// fill in the blocks
	Set<String> addedStudies = new HashSet<String>();
	String firstCellId = null;
	String appendURLBase = "erad" + ( (is.httpx_host == is.https_host) ? "s" : "" ) + "://" + is.http_host.substring( 7 ) + "/appendStudy?cStudy=";
			
	for ( ResultCollectorThread thread : results ) {
		try {
			thread.join();
			Result res = thread.getResult();
			if ( res == null ) {
				throw new IMException( "Thread was interrupted while collecting result" );
			}
			boolean isRemote = res instanceof ArchivesResultImpl;
			
			while (res.next()) {
				String styiuid = res.getValue( "SYUI" );
				if (addedStudies.contains( styiuid )) {
					continue;
				}
				addedStudies.add( styiuid );
				String content = TimeLine.substituteFields( "<nobr>$$DATE$$</nobr><br><span class=\"Capital\">$$PANM$$-$$MODY$$-$$BDYP$$</span>", res );
				String date = res.getValue( "DATE" );

				//  type can be "Remote" (non-local studies), "Opened" (Study which is opened in the user's viewer), "Study" (non-opened study), "Order" 
				String type = "Study";
				String recSrc = "LOCAL";
				if ( isRemote ) {
					recSrc = res.getValue( "RSRC" );
					type = "Remote";
				}
				else if ( OperToolbox.isOrder( styiuid ) ) {
					type = "Order";
				}
				String href = "false";
				if ( "Study".equals( type ) ) {
					href = "\""+appendURLBase + styiuid + "\"";
				}%>
	tc = new IMTimelineCell( '<%=recSrc + "_" + styiuid %>', '<%=styiuid%>', '<%=date%>', '<%=Helper.sqlEncode( content )%>', <%= href %>);
		// only the viewer will set the type to Opened

		// this.setState = function( base, actual, type, selected, outfiltered ) {
		tc.setState( false, '<%=type%>', false, false, false, false, false, false, false);
<%
				if (firstCellId == null) {
					firstCellId = recSrc + "_" + styiuid;
				}
				if ( isRemote ) {
%>
			tc.archiveDevice='<%=recSrc%>';
<%
				}
%>
			timeLine.addObject( tc );
<%
			}
			res.close();
		}
		catch ( InterruptedException e ) {
			Helper.ERRORLOG( "openInfo.jsp", "Thread was interrupted while collecting result" );
			throw new IMException( "Thread was interrupted while collecting result" );
		}
		
	}
	
%>

	new IMTimeLineButtons( 'tlbc', 'tlBox', true, <%=IMSession.isGetPbsServlet()%> );
	addLoadEvent(function(){ timeLine.setActual( '<%=firstCellId%>' );timeLine.render();}, 2);
	var appendURLBase = "<%=appendURLBase%>";
</script>
<%JSHelper.printJsInclude( out, "/cases/js/studyManager.js" );%>
</body>--%>