<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 Component: qr

 Description:
  Web interface for Query/Retrieve client

 Last Updated     : $Author: balage $
 Update Date Time : $Date: 2014/03/05 11:08:09 $
 RCS File Name    : $RCSfile: index.jsp,v $
 RCS Revision     : $Revision: 1.52 $
 Locked by        : $Locker:  $
 Symbolic name    : $Name:  $
 State            : $State: Exp $
-- %><%@page import="imagemed.jsputil.TabToolbox"%>
<%@page import="imagemed.jsputil.QRToolbox"%>
<%@page import="imagemed.http.IMRequest"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%@
	page import="java.util.*,java.io.*, imagemed.imsession.*,imagemed.util.*,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			com.erad.pacs.common.interfaces.result.*"
%><%
	IMSession is = new IMSession(request, response, out); 
	if (!is.regOK()) {
		return;
	}
	
	IMRequest parReq = is.imRequest;

	String parHost = QRToolbox.getcurrentQRHost(parReq);

	String context = parReq.m_context;
	if (context == null || context.length() == 0) {
		parReq.expandList("/qr/index.jsp"); 
		// since we don't do list handling, we might as well expand the default values on the
		// first place to avoid complications...
		context = parReq.backupContext();
		
		response.sendRedirect("/cases/dcfilterb.jsp?cContext="+context+"&cIndexPage=/qr/index.jsp&cIndexTab=QR");
		return;
	}
	else {
		parReq.passAsFile(context);
	}
%><%!
	String strValidLevels = "|PATIENT|STUDY|SERIES|IMAGE|";
%><%String thisPage = "/qr/index.jsp";

	String defaultFields[] = TableParamsImpl.getDefaultFields(thisPage, is);
	String sort[]          = TableParamsImpl.getDefaultSorts(thisPage);
	String extraParams[]   = { "qrHost", "mvHost", "cInfModel" };
	Properties defFilters  = TableParamsImpl.getDefaultFilters(thisPage, is);

	String parFields[]    = parReq.getVals("cFields");

	boolean needSetDefaultFilter = parHost == null && parFields == null;

	Properties prpConfig = new Properties();

	try {
		prpConfig.load(new FileInputStream(IMEnvBase.getEnv("CONF") + "/qrclient.cfg"));
	}
	catch(Throwable th) {}

	String strLevel=parReq.getVal("cLevel");

	if (strLevel == null || -1 == strValidLevels.indexOf("|" + strLevel + "|")) {
		strLevel = prpConfig.getProperty("Level","Study").toUpperCase();
	}
	if (-1 == strValidLevels.indexOf("|" + strLevel + "|")) {
		strLevel = "STUDY";
	}

	// out.println(strInfModel+"/"+strModel+"/"+strLevel);

	TableDescriptorImpl tdesc = new TableDescriptorImpl(thisPage);
	TablePropertiesImpl tprop = new TablePropertiesImpl();
	
	TableParamsImpl tparams = new TableParamsImpl(is.imRequest);
	tparams.setDefaultFields(defaultFields);
	tparams.setDefaultSort(sort);
	tparams.setDefaultPage(1);
	if (needSetDefaultFilter) {
		tparams.setDefaultFilters(defFilters);
	}
	tparams.setDefaultPageSize(20);
	tparams.setExtraParams(extraParams);

	tdesc.setTableParams(tparams);
	tdesc.setTableProperties(tprop);
	tdesc.setSortDepth(3);

//	IMFieldManager fm = (IMFieldManager) new IMDCMFieldManager("Dcfields", "Dctypes", "QR");
//	fm.setFilterMode(IMFieldManager.Q_R);

//	tdesc.setFieldManager(fm);

	tdesc.setFieldManager(new ArchivesFieldManagerImpl( ArchivesFieldManagerImpl.MODE.QR_ARCHIVES, ArchivesFieldManagerImpl.ISSUER.LOCAL ) );

//	String linkPrefix = "/qr/retrieve.jsp?qrHost=" + Helper.URLEncodeUTF8(parHost == null ? "" : parHost);

	ActionImpl act[] = new ActionImpl[2];
	act[0] = new ArchiveCheckbox(tprop, true);
//	act[0] = (Action) new CheckboxAction(tprop, "SYUI", "cGr", null);
	act[1] = new ComboAction(tdesc, ComboAction.TYPE_QR, "rm");


	ActionImpl batchAct[] = new ActionImpl[2];
	batchAct[0] = new LinkAction(tdesc, null, "JavaScript:Batch_(\"Get\")",
			"<IMG SRC=\"/cases/art/get.gif\" width=\"16\" height=\"20\"" +
			" alt=\"Get selected studies\" border=0>",
			"Get selected studies");
	
	batchAct[1] = new LinkAction(tdesc, null, "JavaScript:Batch_(\"Move\")",
			"<IMG SRC=\"/cases/art/forward.gif\" width=\"16\" height=\"20\"" +
			" alt=\"Move selected studies\" border=0>",
			"Move selected studies");
	
	ColumnImpl col = new ColumnImpl(new BatchHeader(batchAct), new ActionCell("SYUI", act), "SYUI"); 
	tdesc.addExtraColumn("_FIRST",col);

	TopCellImpl topCell[] = new TopCellImpl[5];
	topCell[0] = new TitleTopCell(tprop, "Query/Retrieve");
	topCell[1] = new FieldsTopCell(tdesc, null, false);
	topCell[2] = new FiltersTopCell(tdesc, null, false, new String[0], false);
	topCell[3] = new SortsTopCell(tdesc, null, false, false);
	topCell[4] = new PageTopCell(tprop, tparams);

	tdesc.setTopCells(topCell);

	
	ArchivesResultImpl result = new ArchivesResultImpl(tdesc,null);
	result.setRequiredFields( new String[] {"SYUI", "RSRC", "REAE"} );
	
	String resultID = result.getResultID();

	if (resultID != null && !resultID.equals(parReq.getVal("cResultID"))) {
		parReq.setProperty("cResultID", resultID);
		parReq.passAsFile(parReq.m_context);
	}
		
	
	tdesc.setResult(result);

	TableImpl table = new TableImpl(tdesc);

//	boolean isCancelled = result.isCancelled();
//	boolean isCancelled = false;%><%!

//	boolean isHostSelected(String host, String selectedHosts[]) {
//		boolean bSelected = false;
//		if (selectedHosts != null) {
//			for (int i=0; i<selectedHosts.length; i++) {
//				bSelected = host.equals(selectedHosts[i]);
//				if (bSelected) {
//					break;
//				}
//			}
//		}
//		return bSelected;
//	}

	String noPassAtAll = "r_setc,cFields";

%><HTML>
 <HEAD><TITLE>Query/Retrieve</TITLE>
 <SCRIPT Language="JavaScript">
   var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup(out);
	table.printScript(tparams, is, new String[] {ArchiveCheckbox.CHECKBOXNAME});
%>
  <SCRIPT language="JavaScript">

		function Batch_(pOper) {
			if (pOper == 'Move') {
				self.document.Batch.action = '/qr/retrieve.jsp';
			}
			else {
				self.document.Batch.action = '/archive/get.jsp';
			}

			self.document.Batch.submit();
		}


		function submitQuery(frm) {
			frm.submit();
		}

		function forceRetrieve(device, study) {
			text="This study is already being retrieved.\nAre you sure you want to start a new retrieve operation?";
			if (confirm(text)) {
				document.location="/archive/get.jsp?cDevStudy="+device+"+"+study+"&cForced=true";
			}
		}

		function submitRetrieve(frmhosts,frmstudies) {
			var str = "";
			for (i = 0 ; i < frmstudies.elements.length; i++) {
				if (frmstudies.elements[i].checked) {
					str = str + "\n" + frmstudies.elements[i].value;
				}
			}
			frmhosts.mvStudies.value = str.substring(1,str.length);
			frmhosts.submit();
		}
  </SCRIPT>

  </HEAD>
  <BODY>
<%

	TabToolbox.makeTabs( is, is.tabbean, "qr/index.jsp", "White");

	try {
		table.printTableTop(is);
	}
	catch (Throwable th) {
		Helper.DEBUG("qr/index.jsp", Helper.throwable2String(th));
	}

%><%--
<TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
  <tr>
   <td class=BgShadow width=100% valign=top>
   <table border=0 width=100%><tr>
    <FORM action="<%=thisPage%>" name=queryForm>
    <INPUT type="hidden" name="cPage" value="1">
    <INPUT type="hidden" name="cContext" value="<%=context%>">
    <td align=left><%=QRSelectorFormPart.getSelector(true, parHost)%></td>
    <TD align=center>
    </td><td align=right>
<%
	if (isCancelled) {
%><FONT COLOR="#ff0000" SIZE=+1><blink>TRANSFER CANCELLED</blink></font><BR><BR>
<FONT COLOR="#ff0000"> Only partial results are displayed: use stricter filters</font><%
	}
%>
     </td>
     </tr>
     </FORM>
     </table>
   </td>
   </tr>
   <!-- INPUT TYPE=HIDDEN NAME=mvStudies VALUE="" -->
   </FORM>
   </table>
   </td>
  </tr>
</table>

-- %><%-- FORM name=studiesForm -- %>
<%
	try {
		table.printTableWithoutPageNavigation(is);
	}
	catch (Throwable th) {
	}
%>
<%-- /FORM -- %>

<%
	try {
		table.printPageNavigation(is);
	}
	catch (Throwable th) {
	}
%>

<%-- = "<pre>"+result.getDebug()+"</pre>" -- %>

</CENTER>
</BODY></HTML>
--%>