<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *   WorkList page (and QuickView of a study and Prefetch)
 *
 * Parameters:
 *
 *  @param cList_0         [userID/]listName
 *
 *  @param cPreFetch       true at Prefetch request (prefetch session)
 *  @param cQV             STYIUID of viewed study (at QuickView)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page import="java.util.*,java.io.*,java.sql.*,imagemed.imsession.*,imagemed.util.*,imagemed.jsputil.*,imagemed.exception.*,
			imagemed.dcprocessing.*,com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.http.tabs.*,imagemed.dotcom.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	void printError( PrintWriter out, String errMsg ) throws IOException {
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), "100%", "100%", "mbox" );
		mb.setMessage( "<DIV style=\"padding-top: 50px;\" class=\"FontError\">" + errMsg + "</DIV>" );
		mb.print( out );
	
		out.println( "<script language=\"JavaScript\">" );
		out.println( "   setTimeout( 'cancelDel()', 2000 );" );
		out.println( "</script>\n" );
		out.println( "</BODY></HTML>" );
		return;
	}

%><%

	IMSession is = new IMSession(request, response, out);

	is.bRegNotNeeded = true;
	is.regOK( false );
	
%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT" ) %></TITLE><%
	TableImpl.printCommonScript( is );
%>

<STYLE type="text/css">

		 TABLE.mbox {
			 margin: 0px;
		 }
</STYLE>

<SCRIPT language="JavaScript">

	function goBack() {
		if ( parent ) {
			parent.reLoadPage();
			return;
		}

		self.history.back();
	}

	function cancelDel() {
		if ( parent ) {
			parent.cancelDelete();
			return;
		}

		self.history.back();
	}
	
	// Shows the object tools (preview/delete) in a hover over objects
	//
	// @param event   mouseover event
	// @param elem    the thumbnail or icon of the object
	function showInfo( event, elem ) {
		infoDiv = getelementbyid( 'objInfo' );
		infoDiv.style.display = "block";

		var winWidth = document.body.clientWidth;
		if ( typeof( window.innerWidth ) == 'number' ) {
			winWidth = window.innerWidth;
		}

		var elemWidth = infoDiv.clientWidth;
		if ( !elemWidth ) {
			elemWidth = winWidth - 40;
		}

//		alert( 'winWidth: ' + winWidth + '\nElem Width:' + elemWidth );

		
		infoDiv.style.top = ( calcElementTop(elem) + elem.offsetHeight + 5 ) + 'px';
		infoDiv.style.left = ( ( winWidth - elemWidth ) / 2 ) + 'px';
		infoDiv.style.visibility = "visible";
	}

	function hideInfo() {
		infoDiv = getelementbyid( 'objInfo' );
		infoDiv.style.visibility = "hidden";
		infoDiv.style.display = "none";
	}
	
	
</SCRIPT>

</HEAD><BODY style="padding: 0px;">
<%
	if ( is.regID == null ) {
		// Login timeout
		out.println( "<SCRIPT language=\"JavaScript\">parent.reLoadPage();</SCRIPT>" );
		out.println( "</BODY></HTML>" );
		return;
	}

	String parStudy = request.getParameter( "cStudy" );
	String parFile = request.getParameter( "cFile" ); 
	String parOper = request.getParameter( "cOp" );
	String parSumObj = request.getParameter( "cSumObj" );

	if ( parStudy == null || parFile == null || ! ( "Del".equals( parOper ) || "DelConfirmed".equals( parOper ) ) ) {
		printError( is.out, LocalizedMessage.getSimpleMessage( "GENERAL_INVALID_CALL" ) );
		return;
	}

	boolean hasDeleteRight = is.hasRight( PacsRight.Delete.letterString() );

	if ( !hasDeleteRight ) {
		printError( is.out, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELOBJECT_NO_RIGHTS" ) );
		return;
	}
	
	if ( "DelConfirmed".equals( parOper ) ) {
		// Delete confirmed
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT" ), "100%", "100%", "mbox" );
		mb.setMessage( "<DIV id=\"delProgress\" style=\"padding-bottom: 50px; padding-top: 50px;\">" + LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT_DELETING_OBJECT" ) + " ...<BR>" + parStudy +"<BR>" + parFile + "</DIV>" );
		mb.addButton( new Button( "javascript:goBack();", "BUTTON_BACK", "BUTTON_BACK_TITLE" ) );

		mb.print( is.out );
		out.flush();
		
		if(parSumObj == null || parSumObj.equals( "" ) || parSumObj.equals( "-1" )){
	Helper.ERRORLOG( "delObject", "The parSumObj variable's value is " + ((parSumObj == null)? "null" :  parSumObj) );
	out.println( "</BODY>" );
	out.println( "</HTML>" );
	return;
		}
		int intSumObj;
		try{
	intSumObj = Integer.parseInt( parSumObj );
		}catch( NumberFormatException nfe ){
	Helper.ERRORLOG( "delObject", "EXCEPTION: " + Helper.throwable2String( nfe ) );
	out.println( "</BODY>" );
	out.println( "</HTML>" );
	return;
		}
		if ( (intSumObj - 1) <= 0 ) {
	Helper.DEBUG( "delObject", "Unable to delete the last object in study." );
	out.println( "<SCRIPT language=\"JavaScript\">" );
	out.println( "  var progressDiv = getelementbyid( 'delProgress' );" );
	out.println( "  progressDiv.innerHTML = '" + LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT_DELETE_LAST_OBJECT" ) + "';" );
	out.println( "  setTimeout( 'goBack()', 2000);" );
	out.println( "</SCRIPT>" );	
	out.println( "</BODY>" );
	out.println( "</HTML>" );
	return;
		}
		
		try {
	Vector<String> vFile = new Vector<String>();
	vFile.add( parFile );
	
	Helper.INFOLOG( "Deleting " + parStudy + "/" + vFile );
	
	if ( StudyRemover.rmiRemoveFiles( null, parStudy, is.regID, vFile, "Delete user selected object(s)", Boolean.TRUE ).booleanValue() ) {
		out.println( "<SCRIPT language=\"JavaScript\">" );
		out.println( "  var progressDiv = getelementbyid( 'delProgress' );" );
		out.println( "  progressDiv.innerHTML = '" + LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT_HAS_BEEN_DELETED" ) + "';" );
		out.println( "  setTimeout( 'goBack()', 2000);" );
		out.println( "</SCRIPT>" );
	}
		}
		catch( Throwable th ) {
	Helper.ERRORLOG( "delObject", "EXCEPTION: " + Helper.throwable2String( th ) );
	out.println( "<SCRIPT language=\"JavaScript\">" );
	out.println( "  var progressDiv = getelementbyid( 'delProgress' );" );
	out.println( "  progressDiv.className = 'FontError';" );
	out.println( "  progressDiv.innerHTML = '" + LocalizedMessage.getSimpleMessage ( "EXCEPTION_CASES_DELOBJECT_AN_ERROR_OCURRED" ) + "';" );
	out.println( "  setTimeout( 'goBack()', 2000);" );
	out.println( "</SCRIPT>" );
		}
		
		out.println( "</BODY>" );
		out.println( "</HTML>" );
		
		return;
	}
	
	
	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost == null ) {
		redirHost = "";
	}

	QuickViewImages.QuickViewObject qvObject = QuickViewImages.rmiGetObject( null, parStudy, parFile );
	if ( qvObject == null ) {
		printError( is.out, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELOBJECT_OBJ_NOT_FOUND" ) );
		return;
	}
	
	String info = "";
	StringWriter imageWriter = new StringWriter();
	
	if ( qvObject instanceof QuickViewImages.QuickViewNonImageObject ) {
		QuickViewImages.QuickViewNonImageObject obj = (QuickViewImages.QuickViewNonImageObject) qvObject;

		QuickViewIconPrinter qvIcon = new QuickViewIconPrinter( imageWriter, redirHost, false, false );
		info = qvIcon.print( parStudy, obj.getFileName(), obj.getSOPClassUID(), obj.getInstanceNumber(), true) + "\n";
	}
	else { //  QuickViewImages.QuickViewImageObject
		QuickViewImages.QuickViewImageObject img = (QuickViewImages.QuickViewImageObject) qvObject;
		int cols = img.getCols();
		int rows = img.getRows();
		int frames = img.getFrameCount();

		String parSet = "128x128";

		int thnc1 = 128;
		int thnr1 = 128;
		float vr = ( float ) cols / rows;
		if ( vr < 1 )
	thnc1 *= vr;
		if ( vr > 1 )
	thnr1 /= vr;


		imageWriter.write( "<IMG src=\"" + redirHost + "/cases/frame.jsp?f=" + parStudy + "/" + parFile + "_1." + parSet + "w.jpg\"" );
		imageWriter.write( " width=" + thnc1 + " height=" + thnr1 );
		imageWriter.write( " alt=\"" + parFile + " (" +cols + "x" + rows + ")\" border=0>" );

		if ( frames > 1 ) {
	imageWriter.write( "..." );
		}
		
		info = "" + cols + "x" + rows + (frames > 1 ? " [" + frames + "]" : "" );
	}
	
	StringBuilder mbText = new StringBuilder( 1024 );

	mbText.append( "<DIV style=\"padding-bottom: 20px;\">" + LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT_PERMANENTLY_DEL_OBJ" ) + "</DIV>\n" );
	mbText.append( "<DIV><SPAN onMouseOver=\"showInfo( event, this );\" onMouseOut=\"hideInfo();\">" );
	mbText.append( imageWriter.toString() );
	mbText.append( "</SPAN></DIV>" );

	mbText.append( "<FORM name=\"delForm\" method=\"POST\" action=\"delObject.jsp\">\n" );
	mbText.append( "<INPUT TYPE=\"HIDDEN\" NAME=\"cStudy\" VALUE=\"" + Helper.htmlEncode( parStudy )+ "\">" );
	mbText.append( "<INPUT TYPE=\"HIDDEN\" NAME=\"cFile\" VALUE=\"" + Helper.htmlEncode( parFile )+ "\">" );
	mbText.append( "<INPUT TYPE=\"HIDDEN\" NAME=\"cOp\" VALUE=\"DelConfirmed\">" );
	mbText.append( "<INPUT TYPE=\"HIDDEN\" NAME=\"cSumObj\" VALUE=\""+ parSumObj + "\">" );
	mbText.append( "</FORM>\n" );
	
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_DELOBJECT" ), "100%", "100%", "mbox" );
	mb.setMessage( mbText.toString() );
	mb.addButton( new Button( "javascript:self.document.delForm.submit();", "BUTTON_DELETE", "BUTTON_DELETE_OBJECT_TITLE"  ) );
	mb.addButton( new Button( "javascript:cancelDel();", "BUTTON_CANCEL", "BUTTON_CANCEL_OBJ_DEL_TITLE" ) );
	mb.print( is.out );
%>
<DIV class="popup" id="objInfo" style="display: none; padding: 15px">
<%= parFile %><BR>
<%= info %><BR>
</DIV>
</BODY></HTML>

--%>