<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: qc
 *
 * Description:
 *	   Table for
 *         - matching expired orders to studies (Expired Orders)
 *         - list studies having no orders in the Scheduler module (Unmatched studies)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="imagemed.jsputil.TabToolbox"%>
<%@page import="com.erad.pacs.common.interfaces.result.SQLResult"%>
<%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="java.io.*, java.util.*, imagemed.imsession.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
		imagemed.util.*, imagemed.http.*, imagemed.http.tabs.*, imagemed.exception.*, java.text.Format"

%><%!

	static Properties mapSchedulerFields;
	static String schedulerLinkParams = null;

	static {
		mapSchedulerFields = new Properties();
		mapSchedulerFields.setProperty( "ACCN", "ACCN" );
		mapSchedulerFields.setProperty( "PANM", "PANM" );
		mapSchedulerFields.setProperty( "PAID", "PAID" );
		mapSchedulerFields.setProperty( "PDOB", "PDOB" );
		mapSchedulerFields.setProperty( "PSEX", "PSEX" );
		mapSchedulerFields.setProperty( "PHRF", "PHRF" );
		mapSchedulerFields.setProperty( "DSCR", "DSCR" );
		mapSchedulerFields.setProperty( "BDYP", "BDYP" );
		mapSchedulerFields.setProperty( "STNM", "STNM" );
		mapSchedulerFields.setProperty( "SCHD", "DATE" );
		mapSchedulerFields.setProperty( "SCSD", "DATE" );
		mapSchedulerFields.setProperty( "MODY", "MODY" );

		// Requested, but not supported: "CPT4", "PSAE", "ICD9"
		
		StringBuffer sb = new StringBuffer( 256 );
		for ( Enumeration< ? > e =  mapSchedulerFields.propertyNames(); e.hasMoreElements(); ) {
			String fld = (String) e.nextElement();
			sb.append( "&" ).append( fld ).append( "=$$" ).append( mapSchedulerFields.getProperty( fld ) ).append( "$$" );
		}
		
		schedulerLinkParams = "&STAT=-5" + sb.toString();
	};

%><%
	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}
	IMRequest parReq = is.imRequest;
	String context = parReq.m_context;
	if ( context == null || context.length() == 0 ) {
		context = parReq.backupContext();
	}
	else {
		parReq.passAsFile( context );
	}

	String thisPage   = "/qc/index.jsp";
	String mergePage  = "/qc/confirm.jsp";

	String parBack = parReq.getVal( "cBack" );
	String parMore = parReq.getVal( "cMore" );
	String parMode = parReq.getVal( "cMode" );
	boolean isMore = ( parMore != null && !"".equals( parMore ) );

	if ( parMode == null )
		parMode = "exporders";

	
	// isMore  : list all studies to match one order
	//           parMore contains STYIUID of the order
	// !isMore : list all 'expired order' to match studies

	String[] fields = TableParamsImpl.getDefaultFields( thisPage, is );
	String[] sort   = "studies".equals( parMode )
			? new String[] { "d_DATE" } : TableParamsImpl.getDefaultSorts( thisPage );
	String extraParams[]   = { "cMore" , "cMode", "cBack" };

	TableDescriptorImpl tdesc = new TableDescriptorImpl( thisPage );
	TablePropertiesImpl tprop = new TablePropertiesImpl();

	TableParamsImpl tparams = new TableParamsImpl( parReq );
	tparams.setDefaultFields( fields );
	tparams.setDefaultSort( sort );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	tparams.setExtraParams( extraParams );

	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setFieldManager( new IMSQLFieldManagerImpl( "Dcfields", "Dctypes", "Dcstudy" ) );

	QCMergeAction mergeAction = new QCMergeAction( tdesc, "SYUI" );

	String back = tparams.getPassParams();
	if ( back == null )
		back = "";
	if ( back.startsWith( "&" ) )
		back = "?" + back.substring( 1 );

	String backParam = Helper.URLEncodeUTF8( is.httpx_host + thisPage + back );

	// SCHEDULING_RIGHT AND ( ADMIN_RIGHT OR SCHEDULER_CREATE_EDIT_ORDER_RIGHT )
	boolean hasSchedulerRight = is.hasRight( IMTypeur.SCHEDULING_RIGHT ) && is.hasRight( IMTypeur.SCHEDULER_CREATE_EDIT_ORDER_RIGHT ); 
	
	if ( isMore ) {
		String moreBackParam = "&cMoreBack=" + backParam;
		String link = mergePage + "?cOrder=" + parMore + "&cStudy=$$SYUI$$" + moreBackParam +
				tparams.getPassExtraParams();
		String gif  = "<IMG src=\"/cases/art/merge.gif\" width=19 height=17 " +
				"border=none alt=\"" + LocalizedMessage.getSimpleMessage( "QC_INDEX_MERGE_ORDER_TO" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "QC_INDEX_MERGE_ORDER_TO" ) + "\">";
		ActionImpl act[] = new ActionImpl[ 1 ];
		act[ 0 ] = new LinkAction( tdesc, "SYUI", link, gif, LocalizedMessage.getSimpleMessage( "QC_INDEX_MERGE_ORDER_TO" ) );

		ColumnImpl col = new ColumnImpl( new SimpleHeader( LocalizedMessage.getSimpleMessage( "OPER_MERGE" ) ), new ActionCell( "SYUI", act ), "SYUI" );

		tdesc.addExtraColumn( "_FIRST", col );
	}
	else if ( "studies".equals( parMode ) ) {

		if ( !hasSchedulerRight ) {
			throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_NO_SCHEDULER_RIGHTS" ), "qc/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CORRECTION_ERROR_TITLE" ), parBack, 4 );
		}
		ActionImpl act[] = new ActionImpl[ 4 ];
		act[ 0 ] = new QCSchOrderAction( tdesc, QCSchedulerResult.SCH_ORDER_NONE, "ACCN",
				"/scheduler/correction.jsp?cBack=" + backParam + schedulerLinkParams,
				"/cases/art/addElementAfter.gif", "16", "20", LocalizedMessage.getSimpleMessage( "CREATE_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "CREATE_SCHEDULER_ORDER" ) );
		act[ 1 ] = new QCSchOrderAction( tdesc, QCSchedulerResult.SCH_ORDER_NOPACS, "ACCN",
				"/qc/getSchedulerOrder.jsp?cAccno=$$ACCN$$&cBack=" + backParam,
				"/cases/art/get.gif", "16", "20", LocalizedMessage.getSimpleMessage( "GET_SCHEDULER_ORDER" ), LocalizedMessage.getSimpleMessage( "GET_SCHEDULER_ORDER" ) );
		act[ 2 ] = new QCSchOrderAction( tdesc, QCSchedulerResult.SCH_ORDER_MULTIPLE, "ACCN",
				"/scheduler/orders.jsp?cOrderScheduleMode=All+Orders&qf_0ZAN=$$ACCN$$&cBack=" + backParam,
				"/cases/art/listorders.png", "18", "20", LocalizedMessage.getSimpleMessage( "LIST_SCHEDULER_ORDER_PLURAL" ), LocalizedMessage.getSimpleMessage( "LIST_SCHEDULER_ORDER_PLURAL" ) );
		act[ 3 ] = new QCSchOrderAction( tdesc, QCSchedulerResult.SCH_ORDER_STUDY, "ACCN",
				"/cases/index.jsp?qf_ACCN=$$ACCN$$",
				"/cases/art/liststudies.png", "18", "20", LocalizedMessage.getSimpleMessage( "ALT_TEXT_LIST_STUDIES" ), LocalizedMessage.getSimpleMessage( "ALT_TEXT_LIST_STUDIES" ) );
	
		
		ColumnImpl col = new ColumnImpl( new SimpleHeader( LocalizedMessage.getSimpleMessage( "QC_INDEX_UNMATCHED_STUDIES" ) ),
				new ActionCell( "SYUI", new ActionImpl[] { new MultiAction( tprop, act ) } ), "SYUI" );

		tdesc.addExtraColumn( "_FIRST", col );
	}
	else {
		backParam = "&cBack=" + backParam;
		String link = thisPage + "?cMore=$$SYUI$$" + backParam;
		ActionImpl act[] = new ActionImpl[ 3 ];
		act[ 0 ] = new LinkAction( tdesc, "SYUI", "javascript:doConfirmMerge(\"$$SYUI$$\")",
				"<IMG src=\"/cases/art/merge.gif\" width=19 height=17 " +
				"border=none alt=\"" + LocalizedMessage.getSimpleMessage( "OPER_MERGE" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "OPER_MERGE" ) + "\">", LocalizedMessage.getSimpleMessage( "OPER_MERGE" ) );
		act[ 1 ] = new LinkAction( tdesc, "SYUI", link, "<IMG src=\"/cases/art/more.gif\"" +
				" width=19 height=17 border=none alt=\"" + LocalizedMessage.getSimpleMessage( "ALT_TEXT_MORE_STUDIES" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "ALT_TEXT_MORE_STUDIES" ) + "\">",
				LocalizedMessage.getSimpleMessage( "ALT_TEXT_MORE_STUDIES" ) );
		act[ 2 ] = new LinkAction( tdesc, "SYUI", "/cases/delete.jsp?cGr=$$SYUI$$" +
				backParam, "<IMG src=\"/cases/art/delete.gif\" width=17 " +
				"height=20 border=none alt=\"" + LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ) + "\" title=\"" + LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ) + "\">", LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ) );

		ActionImpl actFirst[] = new ActionImpl[ 1 ];
		actFirst[ 0 ]       = new MultiAction( tprop, act );
		ColumnImpl colFirst   = new ColumnImpl( new SimpleHeader( LocalizedMessage.getSimpleMessage( "QC_INDEX_EXPIRED_ORDERS" ) ),
				new ActionCell( "SYUI", actFirst ), "SYUI" );

		tdesc.addExtraColumn( "_FIRST", colFirst );

		ActionImpl actLast[] = new ActionImpl[ 1 ];
		actLast[ 0 ] = mergeAction;
		ColumnImpl colLast = new ColumnImpl( new SimpleHeader( LocalizedMessage.getSimpleMessage( "QC_INDEX_MATCHING_STUDIES" ) ),
				new ActionCell( "SYUI", actLast ), "SYUI" );

		tdesc.addExtraColumn( "_LAST", colLast );
	}

	int tcCount = 0;

	Vector< TopCellImpl > topCells = new Vector< TopCellImpl >( 8 );

	Properties titleCellPrp = new Properties();
	titleCellPrp.setProperty( "width", "20%" );

	topCells.add( new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "tabCorrections"), titleCellPrp ) );
	if ( TabBean.hasSchedulerLicense() && hasSchedulerRight ) {
		Vector< String[] > pages = new Vector< String[] >( 2 );
		pages.add( new String[] { thisPage + "?cMode=exporders", LocalizedMessage.getSimpleMessage( "QC_INDEX_EXPIRED_ORDERS" ) } );
		pages.add( new String[] { thisPage + "?cMode=studies", LocalizedMessage.getSimpleMessage( "QC_INDEX_MATCHING_STUDIES" ) } );
		topCells.add( new PageSelectorTopCell( tprop, pages, thisPage + "?cMode=" + parMode ) );
		topCells.add( new SeparatorTopCell( tprop, 20 ) );
	}
	
	topCells.add( new FieldsTopCell( tdesc, null, false ) );
	topCells.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], false ) );
	if ( isMore ) {
		topCells.add( new SimpleTopCell( tprop,
				"<A HREF=\"" + parBack + "\" onMouseOver=\"window.status='Back to QC List page'; return true;\">" +
				JSHelper.getJsLocalizedButton( "BUTTON_BACK", "ALT_TEXT_BACK_TO_QC_LIST", false ) + 
				"</A>" ) );
	}
	topCells.add( new PageTopCell( tprop, tparams ) );

	tdesc.setTopCells( topCells.toArray( new TopCellImpl[ 0 ] ) );

	SQLResult result = "studies".equals( parMode ) ? new QCSchedulerResult( is, tdesc ) :
			new QCMergeResult( tdesc, isMore );

	tdesc.setResult( result );

	TableImpl table = new TableImpl( tdesc );%><HTML>
	<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "tabCorrections" ) %></TITLE>
	<SCRIPT Language="JavaScript">
		var pageContext="<%=context%>";
	</script>
<%
	TabToolbox.writeIMpopup( out );
	table.printScript( tparams, is );

	String mergeLinkPrefix = is.httpx_host + mergePage;
%>
	<script language="JavaScript">

		function doSubmit(frm)
		{
			frm.submit();
		}

		function doSubmit2(frm,value)
		{
			frm.elements[0].value = value;
			frm.submit();
		}

		function doConfirmDelete(order)
		{
			alert (LocalizedMessage.getSimpleMessage( "DELETE_SCHEDULER_ORDER" ) + ": " + order);
		}

		function getValue(optarray)
		{
			var ndx = optarray.selectedIndex;
			return optarray[ndx].value;
		}

		function doConfirmMerge(order)
		{
			var vname = "match_" + order;
			var study = null
			for (var i = 0; i < self.document.mergeForm.elements.length; i++)
			{
				if (self.document.mergeForm.elements[i].name == vname)
				study = getValue(self.document.mergeForm.elements[i].options);
			}

			var mergeURL = "<%= mergeLinkPrefix %>?cOrder=" + order + "&cStudy=" + study + "<%= backParam %>";
			self.document.location = mergeURL;
		}

	</script>

	</HEAD>
	<BODY><CENTER>
<%
	TabToolbox.makeTabs( is, is.tabbean, "qc/index.jsp", "White" );

	try {
		table.printTableTop( is );
	}
	catch ( Throwable th ) {
		Helper.DEBUG( "qc/index.jsp", Helper.throwable2String( th ) );
	}

	try {
		if ( isMore ) {
%><H3><%= LocalizedMessage.getCompoundMessage( "QC_INDEX_MERGE_TO", new Format[] { null }, new Object[] { mergeAction.getStudyAttributes( parMore, (QCMergeResult) result, is ) }, true) %></h3><%
			table.print( is );
		}
		else {
			table.printTableWithoutPageNavigation( is, "mergeForm", true );
			table.printPageNavigation( is );
		}
	}
	catch ( Throwable th ) {
%><pre><%
		out.println( th.toString() );
		th.printStackTrace( new PrintWriter( out ) );
%></pre><%
	}
%><%--
<pre>
<%= result.getDebug() %>
</pre>
-- %>
</CENTER>
</BODY></HTML>
--%>